% Dibuix d'una banda de Moebius
% (codi amb Matlab i apte també per a Octave)
% Geometria Diferencial, FME, UPC
% 2021/02/12

% Paràmetres de la banda de Moebius
r = 11; % radi de la banda
t = linspace(0, 2*pi, 101);
zor = linspace(-1, 1, 21); % ample de la banda

% Taula de punts de la banda
for k = 1:length(t)
  A = [
    cos(t(k)) -sin(t(k)) 0
    sin(t(k)) cos(t(k)) 0
    0 0 1
  ];
  B = [
    1 0 0
    0 cos(t(k)/2) -sin(t(k)/2)
    0 sin(t(k)/2) cos(t(k)/2)
  ];

  for l = 1:length(zor)
    phi = A*(B*[0; r; zor(l)] + [0; r; 0]);
    x(k, l) = phi(1);
    y(k, l) = phi(2);
    z(k, l) = phi(3);
  end
end

% Dibuixem la superfície
%xlabel('x');
%ylabel('y');
%zlabel('z');
surf(x, y, z);
print("01.png", "-dpng")
%axis equal
